
#!/usr/bin/python


import random

l = []
N = 20

for i in range(N):
    l.append(random.randint(1, 100))

print l


def left(i):
    """
    Returns the left child of a node i.
    """
    return 2 * i


def right(i):
    """
    Returns the right child of a node i.
    """
    return left(i) + 1


def up(i):
    """
    Returns the parent of a node i.
    """
    return i / 2


def swap(l, n1, n2):
    """
    Swaps values in nodes n1 and n2 if l[n1] > l[n2].
    Returns True if nodes were swapped.
    """

    if l[n1] > l[n2]:
        l[n1], l[n2] = l[n2], l[n1]
        return True

    return False


def heapify(l, leaf):
    """
    Assumes that l[0:leaf] is a heap and ensures that l[0:leaf + 1] is a heap also.
    Migrates a value in l[leaf] towards a tree root as far as necessary.
    """

    if leaf == 0:
        return

    if swap(l, leaf, up(leaf)):
        heapify(l, up(leaf))


def push_down(l, root, N):
    """
    Assumes that both subtrees in left(root) and right(root) satisfy a heap condition,
    and ensures that a tree starting in root also does by pushing a value in l[root] down if necessary.

    Only values in l[0:N] are processed.
    """

    if left(root) >= N:
        return

    next = left(root)

    if right(root) < N and l[next] < l[right(root)]:
        next = right(root)

    if swap(l, next, root):
        push_down(l, next, N)


def build_heap(l, N):
    """
    Ensures that l[0:N] is a heap.
    """
    for i in range(N):
        heapify(l, i)


def sort_heap(l, N):
    """
    Converts a heap into a sorted list.

    """
    for i in range(N - 1, 0, -1):
        l[0], l[i] = l[i], l[0]
        push_down(l, 0, i)


def heapsort(l):
    """
    Sorts list using a HeapSort algorithm.
    """

    N = len(l)
    build_heap(l, N)
    sort_heap(l, N)


heapsort(l)

print l
